SystemOrganization addCategory: #'Glamour-Chartet-Presentations'!

GLMMorphicWidgetRenderer subclass: #GLMMorphicChartetRenderer
	instanceVariableNames: 'myMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Chartet-Presentations'!

!GLMMorphicChartetRenderer methodsFor: 'rendering' stamp: 'TudorGirba 9/3/2013 07:06'!
actOnPresentationUpdate: ann
	| aView |
	aView := ROMondrianViewBuilder new.
	ann presentation renderOn: aView.
	myMorph setView: aView stack! !

!GLMMorphicChartetRenderer methodsFor: 'rendering' stamp: 'TudorGirba 9/3/2013 07:42'!
render: aChartetPresentation
	| builder |
	builder := aChartetPresentation chartetBuilder.
	aChartetPresentation renderOn: aChartetPresentation chartetBuilder.
	aChartetPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	builder openIn: builder rawView.
	^ myMorph := ROPlatform current hostVisualElement on: builder stack! !

GLMScriptingEditorTemplate subclass: #GLMChartetEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Chartet-Presentations'!

!GLMChartetEditor commentStamp: '<historical>' prior: 0!
This browser offers a Glamour-based editor for Chartet charts.

Example:
self openOn: {#variable->'value'}

This will open the editor with a variable named #variable whose value will be 'value'.!

!GLMChartetEditor methodsFor: 'building' stamp: 'TudorGirba 9/3/2013 07:00'!
defaultScriptBindings
	^ {#chart -> GETDiagramBuilder new}! !

!GLMChartetEditor methodsFor: 'building' stamp: 'TudorGirba 9/3/2013 07:00'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation 
		display: 'chart'
		"morphicAct: [:text | GLMEyeSeeExamplesBrowser open ] 
			icon: GLMUIThemeExtraIcons glamorousExample 
			entitled: 'Browse basic examples'"! !

!GLMChartetEditor methodsFor: 'building' stamp: 'TudorGirba 9/3/2013 07:00'!
defaultTitle
	^ 'Chartet Editor'! !

!GLMChartetEditor methodsFor: 'private' stamp: 'TudorGirba 9/3/2013 06:51'!
evaluate: script in: context for: view
	| message |
	^ [ Compiler new evaluate: script in: context to: context ]
		on: Error
		do: [ :e | 
			message := e class name , ': ' , e messageText.
			self inform: message.
			view shape label color: Color red lighter; withText .
			view node: message ]! !

!GLMChartetEditor methodsFor: 'building' stamp: 'TudorGirba 9/3/2013 07:46'!
resultIn: a
	^ a chartet
		title: 'View';
		chart: [ :chart :bindings :script | 
					| context |
					context := GLMDoItContext with: #chart -> chart withAll: bindings.
					self evaluate: script in: context for: chart ]! !

!GLMCompositePresentation methodsFor: '*glamour-chartet-presentations' stamp: 'TudorGirba 9/3/2013 07:47'!
chartet
	^ self custom: GLMChartetPresentation new! !

!GLMMorphicRenderer methodsFor: '*glamour-chartet-presentations' stamp: 'TudorGirba 9/3/2013 07:34'!
renderChartetPresentation: aGLMChartetPresentation 
	^ GLMMorphicChartetRenderer render: aGLMChartetPresentation from: self! !

GLMPresentation subclass: #GLMChartetPresentation
	instanceVariableNames: 'renderer canvas diagramBlock eyeSeeRenderer selectedElement chartetBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Chartet-Presentations'!

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:01'!
canvas
	^ canvas! !

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:01'!
canvas: anObject
	canvas := anObject! !

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:13'!
chart

	^ diagramBlock! !

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:12'!
chart: aBlock
	"use this one to set the "
	diagramBlock := aBlock! !

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:03'!
chartetBuilder
	^ chartetBuilder ifNil: [ chartetBuilder := GETDiagramBuilder new]! !

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:03'!
chartetBuilder: aBuilder
	chartetBuilder := aBuilder ! !

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:01'!
defaultActions
	self
		act: [ :eyesee | eyesee canvas exportAsPNG ] 
			entitled: 'Export as PNG'! !

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:12'!
diagram: aBlock
	self chart: aBlock! !

!GLMChartetPresentation methodsFor: 'initialize-release' stamp: 'TudorGirba 9/3/2013 07:01'!
initialize
	super initialize.
	self defaultActions! !

!GLMChartetPresentation methodsFor: 'rendering' stamp: 'TudorGirba 9/3/2013 07:04'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^aRenderer renderChartetPresentation: self! !

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:31'!
renderOn: aBuilder
	self flag: 'find a smarter solution that does not depend on isKindOf:'. 
	self chart glamourValue: (
		(self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: aBuilder) , self entity , (GLMMultiValue with: self)] 
				ifFalse: [GLMMultiValue with: aBuilder with: self entity with: self])! !

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:01'!
selectedElement 

	^ selectedElement ! !

!GLMChartetPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/3/2013 07:01'!
selectedElement: anElement

	^ selectedElement := anElement ! !
